/[gentoo-x86]/eclass/kde4-base.eclass
Gentoo

Contents of /eclass/kde4-base.eclass

Parent Directory Parent Directory | Revision Log Revision Log


Revision 1.110 - (show annotations) (download)
Sat Oct 29 15:07:16 2011 UTC (2 years, 9 months ago) by abcd
Branch: MAIN
Changes since 1.109: +9 -6 lines
Sync kde4 eclasses

1 # Copyright 1999-2010 Gentoo Foundation
2 # Distributed under the terms of the GNU General Public License v2
3 # $Header: /var/cvsroot/gentoo-x86/eclass/kde4-base.eclass,v 1.105 2011/07/27 09:30:46 alexxy Exp $
4
5 # @ECLASS: kde4-base.eclass
6 # @MAINTAINER:
7 # kde@gentoo.org
8 # @BLURB: This eclass provides functions for kde 4.X ebuilds
9 # @DESCRIPTION:
10 # The kde4-base.eclass provides support for building KDE4 based ebuilds
11 # and KDE4 applications.
12 #
13 # NOTE: KDE 4 ebuilds currently support EAPI "3". This will be reviewed
14 # over time as new EAPI versions are approved.
15
16 # @ECLASS-VARIABLE: VIRTUALX_REQUIRED
17 # @DESCRIPTION:
18 # For proper description see virtualx.eclass manpage.
19 # Here we redefine default value to be manual, if your package needs virtualx
20 # for tests you should proceed with setting VIRTUALX_REQUIRED=test.
21 : ${VIRTUALX_REQUIRED:=manual}
22
23 inherit kde4-functions toolchain-funcs fdo-mime gnome2-utils base virtualx versionator eutils
24
25 if [[ ${BUILD_TYPE} = live ]]; then
26 case ${KDE_SCM} in
27 svn) inherit subversion ;;
28 git) inherit git-2 ;;
29 esac
30 fi
31
32 # @ECLASS-VARIABLE: CMAKE_REQUIRED
33 # @DESCRIPTION:
34 # Specify if cmake buildsystem is being used. Possible values are 'always' and 'never'.
35 # Please note that if it's set to 'never' you need to explicitly override following phases:
36 # src_configure, src_compile, src_test and src_install.
37 # Defaults to 'always'.
38 : ${CMAKE_REQUIRED:=always}
39 if [[ ${CMAKE_REQUIRED} = always ]]; then
40 buildsystem_eclass="cmake-utils"
41 export_fns="src_configure src_compile src_test src_install"
42 fi
43
44 # @ECLASS-VARIABLE: KDE_MINIMAL
45 # @DESCRIPTION:
46 # This variable is used when KDE_REQUIRED is set, to specify required KDE minimal
47 # version for apps to work. Currently defaults to 4.4
48 # One may override this variable to raise version requirements.
49 # Note that it is fixed to ${PV} for kde-base packages.
50 KDE_MINIMAL="${KDE_MINIMAL:-4.4}"
51
52 # Set slot for KDEBASE known packages
53 case ${KDEBASE} in
54 kde-base)
55 SLOT=4
56 KDE_MINIMAL="${PV}"
57 ;;
58 koffice)
59 SLOT="2"
60 ;;
61 kdevelop)
62 if [[ ${BUILD_TYPE} = live ]]; then
63 # @ECLASS-VARIABLE: KDEVELOP_VERSION
64 # @DESCRIPTION:
65 # Specifies KDevelop version. Default is 4.0.0 for tagged packages and 9999 for live packages.
66 # Applies to KDEBASE=kdevelop only.
67 KDEVELOP_VERSION="${KDEVELOP_VERSION:-9999}"
68 # @ECLASS-VARIABLE: KDEVPLATFORM_VERSION
69 # @DESCRIPTION:
70 # Specifies KDevplatform version. Default is 1.0.0 for tagged packages and 9999 for live packages.
71 # Applies to KDEBASE=kdevelop only.
72 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-9999}"
73 else
74 case ${PN} in
75 kdevelop|quanta)
76 KDEVELOP_VERSION=${PV}
77 KDEVPLATFORM_VERSION="$(($(get_major_version)-3)).$(get_after_major_version)"
78 ;;
79 kdevplatform)
80 KDEVELOP_VERSION="$(($(get_major_version)+3)).$(get_after_major_version)"
81 KDEVPLATFORM_VERSION=${PV}
82 ;;
83 *)
84 KDEVELOP_VERSION="${KDEVELOP_VERSION:-4.0.0}"
85 KDEVPLATFORM_VERSION="${KDEVPLATFORM_VERSION:-1.0.0}"
86 esac
87 fi
88 SLOT="4"
89 ;;
90 esac
91
92 inherit ${buildsystem_eclass}
93
94 EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare ${export_fns} pkg_preinst pkg_postinst pkg_postrm
95
96 unset buildsystem_eclass
97 unset export_fns
98
99 # @ECLASS-VARIABLE: DECLARATIVE_REQUIRED
100 # @DESCRIPTION:
101 # Is qt-declarative required? Possible values are 'always', 'optional' and 'never'.
102 # This variable must be set before inheriting any eclasses. Defaults to 'never'.
103 DECLARATIVE_REQUIRED="${DECLARATIVE_REQUIRED:-never}"
104
105 # @ECLASS-VARIABLE: QTHELP_REQUIRED
106 # @DESCRIPTION:
107 # Is qt-assistant required? Possible values are 'always', 'optional' and 'never'.
108 # This variable must be set before inheriting any eclasses. Defaults to 'never'.
109 QTHELP_REQUIRED="${QTHELP_REQUIRED:-never}"
110
111 # @ECLASS-VARIABLE: OPENGL_REQUIRED
112 # @DESCRIPTION:
113 # Is qt-opengl required? Possible values are 'always', 'optional' and 'never'.
114 # This variable must be set before inheriting any eclasses. Defaults to 'never'.
115 OPENGL_REQUIRED="${OPENGL_REQUIRED:-never}"
116
117 # @ECLASS-VARIABLE: MULTIMEDIA_REQUIRED
118 # @DESCRIPTION:
119 # Is qt-multimedia required? Possible values are 'always', 'optional' and 'never'.
120 # This variable must be set before inheriting any eclasses. Defaults to 'never'.
121 MULTIMEDIA_REQUIRED="${MULTIMEDIA_REQUIRED:-never}"
122
123 # @ECLASS-VARIABLE: CPPUNIT_REQUIRED
124 # @DESCRIPTION:
125 # Is cppunit required for tests? Possible values are 'always', 'optional' and 'never'.
126 # This variable must be set before inheriting any eclasses. Defaults to 'never'.
127 CPPUNIT_REQUIRED="${CPPUNIT_REQUIRED:-never}"
128
129 # @ECLASS-VARIABLE: KDE_REQUIRED
130 # @DESCRIPTION:
131 # Is kde required? Possible values are 'always', 'optional' and 'never'.
132 # This variable must be set before inheriting any eclasses. Defaults to 'always'
133 # If set to 'always' or 'optional', KDE_MINIMAL may be overriden as well.
134 # Note that for kde-base packages this variable is fixed to 'always'.
135 KDE_REQUIRED="${KDE_REQUIRED:-always}"
136
137 # @ECLASS-VARIABLE: KDE_HANDBOOK
138 # @DESCRIPTION:
139 # Set to enable handbook in application. Possible values are 'always', 'optional'
140 # (handbook USE flag) and 'never'.
141 # This variable must be set before inheriting any eclasses. Defaults to 'never'.
142 # It adds default handbook dirs for kde-base packages to KMEXTRA and in any case it
143 # ensures buildtime and runtime dependencies.
144 KDE_HANDBOOK="${KDE_HANDBOOK:-never}"
145
146 # @ECLASS-VARIABLE: KDE_LINGUAS_LIVE_OVERRIDE
147 # @DESCRIPTION:
148 # Set this varible if you want your live package to manage its
149 # translations. (Mostly all kde ebuilds does not ship documentation
150 # and translations in live ebuilds)
151 if [[ ${BUILD_TYPE} == live && -z ${KDE_LINGUAS_LIVE_OVERRIDE} ]]; then
152 # Kdebase actualy provides the handbooks even for live stuff
153 [[ ${KDEBASE} == kde-base ]] || KDE_HANDBOOK=never
154 KDE_LINGUAS=""
155 fi
156
157 # Setup packages inheriting this eclass
158 case ${KDEBASE} in
159 kde-base)
160 HOMEPAGE="http://www.kde.org/"
161 LICENSE="GPL-2"
162 if [[ $BUILD_TYPE = live ]]; then
163 # Disable tests for live ebuilds
164 RESTRICT+=" test"
165 fi
166
167 # Only add the kdeprefix USE flag for older versions, to help
168 # non-portage package managers handle the upgrade
169 if [[ ${PV} < 4.6.4 && ( ( ${KMNAME} != kdepim && ${PN} != kdepim-runtime ) || ${PV} < 4.6 ) ]]; then
170 IUSE+=" kdeprefix"
171 fi
172
173 # This code is to prevent portage from searching GENTOO_MIRRORS for
174 # packages that will never be mirrored. (As they only will ever be in
175 # the overlay).
176 case ${PV} in
177 *9999* | 4.?.[6-9]?)
178 RESTRICT+=" mirror"
179 ;;
180 esac
181 ;;
182 koffice)
183 HOMEPAGE="http://www.koffice.org/"
184 LICENSE="GPL-2"
185 ;;
186 kdevelop)
187 HOMEPAGE="http://www.kdevelop.org/"
188 LICENSE="GPL-2"
189 ;;
190 esac
191
192 # @ECLASS-VARIABLE: QT_MINIMAL
193 # @DESCRIPTION:
194 # Determine version of qt we enforce as minimal for the package.
195 if version_is_at_least 4.5.50 "${KDE_MINIMAL}"; then
196 QT_MINIMAL="${QT_MINIMAL:-4.7.0}"
197 else
198 QT_MINIMAL="${QT_MINIMAL:-4.6.3}"
199 fi
200
201 # Declarative dependencies
202 qtdeclarativedepend="
203 >=x11-libs/qt-declarative-${QT_MINIMAL}:4
204 "
205 case ${DECLARATIVE_REQUIRED} in
206 always)
207 COMMONDEPEND+=" ${qtdeclarativedepend}"
208 ;;
209 optional)
210 IUSE+=" declarative"
211 COMMONDEPEND+=" declarative? ( ${qtdeclarativedepend} )"
212 ;;
213 *) ;;
214 esac
215 unset qtdeclarativedepend
216
217 # QtHelp dependencies
218 qthelpdepend="
219 >=x11-libs/qt-assistant-${QT_MINIMAL}:4
220 "
221 case ${QTHELP_REQUIRED} in
222 always)
223 COMMONDEPEND+=" ${qthelpdepend}"
224 ;;
225 optional)
226 IUSE+=" qthelp"
227 COMMONDEPEND+=" qthelp? ( ${qthelpdepend} )"
228 ;;
229 esac
230 unset qthelpdepend
231
232 # OpenGL dependencies
233 qtopengldepend="
234 >=x11-libs/qt-opengl-${QT_MINIMAL}:4
235 "
236 case ${OPENGL_REQUIRED} in
237 always)
238 COMMONDEPEND+=" ${qtopengldepend}"
239 ;;
240 optional)
241 IUSE+=" opengl"
242 COMMONDEPEND+=" opengl? ( ${qtopengldepend} )"
243 ;;
244 *) ;;
245 esac
246 unset qtopengldepend
247
248 # MultiMedia dependencies
249 qtmultimediadepend="
250 >=x11-libs/qt-multimedia-${QT_MINIMAL}:4
251 "
252 case ${MULTIMEDIA_REQUIRED} in
253 always)
254 COMMONDEPEND+=" ${qtmultimediadepend}"
255 ;;
256 optional)
257 IUSE+=" multimedia"
258 COMMONDEPEND+=" multimedia? ( ${qtmultimediadepend} )"
259 ;;
260 *) ;;
261 esac
262 unset qtmultimediadepend
263
264 # CppUnit dependencies
265 cppuintdepend="
266 dev-util/cppunit
267 "
268 case ${CPPUNIT_REQUIRED} in
269 always)
270 DEPEND+=" ${cppuintdepend}"
271 ;;
272 optional)
273 IUSE+=" test"
274 DEPEND+=" test? ( ${cppuintdepend} )"
275 ;;
276 *) ;;
277 esac
278 unset cppuintdepend
279
280
281 # WebKit use dependencies
282 case ${KDE_REQUIRED} in
283 always)
284 qtwebkitusedeps="[kde]"
285 ;;
286 optional)
287 qtwebkitusedeps="[kde?]"
288 ;;
289 *) ;;
290 esac
291 # KDE dependencies
292 # Qt accessibility classes are needed in various places, bug 325461
293 kdecommondepend="
294 dev-lang/perl
295 >=x11-libs/qt-core-${QT_MINIMAL}:4[qt3support,ssl]
296 >=x11-libs/qt-gui-${QT_MINIMAL}:4[accessibility,dbus]
297 >=x11-libs/qt-qt3support-${QT_MINIMAL}:4[accessibility,kde]
298 >=x11-libs/qt-script-${QT_MINIMAL}:4
299 >=x11-libs/qt-sql-${QT_MINIMAL}:4[qt3support]
300 >=x11-libs/qt-svg-${QT_MINIMAL}:4
301 >=x11-libs/qt-test-${QT_MINIMAL}:4
302 >=x11-libs/qt-webkit-${QT_MINIMAL}:4${qtwebkitusedeps}
303 !aqua? (
304 x11-libs/libXext
305 x11-libs/libXt
306 x11-libs/libXxf86vm
307 x11-libs/libXcomposite
308 x11-libs/libxkbfile
309 )
310 "
311
312 if [[ ${PN} != kdelibs ]]; then
313 kdecommondepend+=" $(add_kdebase_dep kdelibs)"
314 if [[ ${KDEBASE} = kdevelop ]]; then
315 if [[ ${PN} != kdevplatform ]]; then
316 # @ECLASS-VARIABLE: KDEVPLATFORM_REQUIRED
317 # @DESCRIPTION:
318 # Specifies whether kdevplatform is required. Possible values are 'always' (default) and 'never'.
319 # Applies to KDEBASE=kdevelop only.
320 KDEVPLATFORM_REQUIRED="${KDEVPLATFORM_REQUIRED:-always}"
321 case ${KDEVPLATFORM_REQUIRED} in
322 always)
323 kdecommondepend+="
324 >=dev-util/kdevplatform-${KDEVPLATFORM_VERSION}
325 "
326 ;;
327 *) ;;
328 esac
329 fi
330 fi
331 fi
332
333 kdedepend="
334 dev-util/automoc
335 dev-util/pkgconfig
336 !aqua? (
337 >=x11-libs/libXtst-1.1.0
338 x11-proto/xf86vidmodeproto
339 )
340 "
341
342 kderdepend=""
343
344 # all packages needs oxygen icons for basic iconset
345 if [[ ${PN} != oxygen-icons ]]; then
346 kderdepend+=" $(add_kdebase_dep oxygen-icons)"
347 fi
348
349 # add a dependency over kde-l10n if EAPI4 or better is around
350 if [[ ${KDEBASE} != "kde-base" && -n ${KDE_LINGUAS} && ${EAPI:-0} != 3 ]]; then
351 for _lingua in ${KDE_LINGUAS}; do
352 # if our package has lignuas, pull in kde-l10n with selected lingua enabled,
353 # but only for selected ones.
354 # this can't be done on one line because if user doesn't use any localisation
355 # then he is probably not interested in kde-l10n at all.
356 kderdepend+="
357 linguas_${_lingua}? ( $(add_kdebase_dep kde-l10n "linguas_${_lingua}(+)") )
358 "
359 done
360 unset _lingua
361 fi
362
363 kdehandbookdepend="
364 app-text/docbook-xml-dtd:4.2
365 app-text/docbook-xsl-stylesheets
366 "
367 kdehandbookrdepend="
368 $(add_kdebase_dep kdelibs 'handbook')
369 "
370 case ${KDE_HANDBOOK} in
371 always)
372 kdedepend+=" ${kdehandbookdepend}"
373 [[ ${PN} != kdelibs ]] && kderdepend+=" ${kdehandbookrdepend}"
374 ;;
375 optional)
376 IUSE+=" +handbook"
377 kdedepend+=" handbook? ( ${kdehandbookdepend} )"
378 [[ ${PN} != kdelibs ]] && kderdepend+=" handbook? ( ${kdehandbookrdepend} )"
379 ;;
380 *) ;;
381 esac
382 unset kdehandbookdepend kdehandbookrdepend
383
384 case ${KDE_REQUIRED} in
385 always)
386 IUSE+=" aqua"
387 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" ${kdecommondepend}"
388 [[ -n ${kdedepend} ]] && DEPEND+=" ${kdedepend}"
389 [[ -n ${kderdepend} ]] && RDEPEND+=" ${kderdepend}"
390 ;;
391 optional)
392 IUSE+=" aqua kde"
393 [[ -n ${kdecommondepend} ]] && COMMONDEPEND+=" kde? ( ${kdecommondepend} )"
394 [[ -n ${kdedepend} ]] && DEPEND+=" kde? ( ${kdedepend} )"
395 [[ -n ${kderdepend} ]] && RDEPEND+=" kde? ( ${kderdepend} )"
396 ;;
397 *) ;;
398 esac
399
400 unset kdecommondepend kdedepend kderdepend
401
402 debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: COMMONDEPEND is ${COMMONDEPEND}"
403 debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: DEPEND (only) is ${DEPEND}"
404 debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: RDEPEND (only) is ${RDEPEND}"
405
406 # Accumulate dependencies set by this eclass
407 DEPEND+=" ${COMMONDEPEND}"
408 RDEPEND+=" ${COMMONDEPEND}"
409 unset COMMONDEPEND
410
411 # Add experimental kdeenablefinal, masked by default
412 IUSE+=" kdeenablefinal"
413
414 # Fetch section - If the ebuild's category is not 'kde-base' and if it is not a
415 # koffice ebuild, the URI should be set in the ebuild itself
416 _calculate_src_uri() {
417 debug-print-function ${FUNCNAME} "$@"
418
419 local _kmname _kmname_pv
420
421 # we calculate URI only for known KDEBASE modules
422 [[ -n ${KDEBASE} ]] || return
423
424 # calculate tarball module name
425 if [[ -n ${KMNAME} ]]; then
426 # fixup kdebase-apps name
427 case ${KMNAME} in
428 kdebase-apps)
429 _kmname="kdebase" ;;
430 *)
431 _kmname="${KMNAME}" ;;
432 esac
433 else
434 _kmname=${PN}
435 fi
436 _kmname_pv="${_kmname}-${PV}"
437 case ${KDEBASE} in
438 kde-base)
439 case ${PV} in
440 4.[456].8[05] | 4.[456].9[023568])
441 # Unstable KDE SC releases
442 SRC_URI="mirror://kde/unstable/${PV}/src/${_kmname_pv}.tar.bz2"
443 if ! version_is_at_least 4.6.80 ${PV}
444 then
445 # KDEPIM IS SPECIAL
446 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/unstable/kdepim/${PV}/${_kmname_pv}.tar.bz2"
447 fi
448 ;;
449 *)
450 # Stable KDE SC releases
451 SRC_URI="mirror://kde/stable/${PV}/src/${_kmname_pv}.tar.bz2"
452 if ! version_is_at_least 4.6.80 ${PV}
453 then
454 # KDEPIM IS SPECIAL
455 # TODO: It might not be with KDE 4.7 (see above)
456 [[ ${KMNAME} == "kdepim" || ${KMNAME} == "kdepim-runtime" ]] && SRC_URI="mirror://kde/stable/kdepim-${PV}/src/${_kmname_pv}.tar.bz2"
457 fi
458 ;;
459 esac
460 ;;
461 koffice)
462 case ${PV} in
463 2.[1234].[6-9]*) SRC_URI="mirror://kde/unstable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
464 *) SRC_URI="mirror://kde/stable/${_kmname_pv}/${_kmname_pv}.tar.bz2" ;;
465 esac
466 ;;
467 kdevelop)
468 SRC_URI="mirror://kde/stable/kdevelop/${KDEVELOP_VERSION}/src/${P}.tar.bz2"
469 ;;
470 esac
471 }
472
473 _calculate_live_repo() {
474 debug-print-function ${FUNCNAME} "$@"
475
476 SRC_URI=""
477 case ${KDE_SCM} in
478 svn)
479 # Determine branch URL based on live type
480 local branch_prefix
481 case ${PV} in
482 9999*)
483 # trunk
484 branch_prefix="trunk/KDE"
485 ;;
486 *)
487 # branch
488 branch_prefix="branches/KDE/$(get_kde_version)"
489 # @ECLASS-VARIABLE: ESVN_PROJECT_SUFFIX
490 # @DESCRIPTION
491 # Suffix appended to ESVN_PROJECT depending on fetched branch.
492 # Defaults is empty (for -9999 = trunk), and "-${PV}" otherwise.
493 ESVN_PROJECT_SUFFIX="-${PV}"
494 ;;
495 esac
496 # @ECLASS-VARIABLE: ESVN_MIRROR
497 # @DESCRIPTION:
498 # This variable allows easy overriding of default kde mirror service
499 # (anonsvn) with anything else you might want to use.
500 ESVN_MIRROR=${ESVN_MIRROR:=svn://anonsvn.kde.org/home/kde}
501 # Split ebuild, or extragear stuff
502 if [[ -n ${KMNAME} ]]; then
503 ESVN_PROJECT="${KMNAME}${ESVN_PROJECT_SUFFIX}"
504 if [[ -z ${KMNOMODULE} ]] && [[ -z ${KMMODULE} ]]; then
505 KMMODULE="${PN}"
506 fi
507 # Split kde-base/ ebuilds: (they reside in trunk/KDE)
508 case ${KMNAME} in
509 kdebase-*)
510 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdebase/${KMNAME#kdebase-}"
511 ;;
512 kdelibs-*)
513 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/kdelibs/${KMNAME#kdelibs-}"
514 ;;
515 kdereview*)
516 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
517 ;;
518 kdesupport)
519 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
520 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
521 ;;
522 kde*)
523 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${KMNAME}"
524 ;;
525 extragear*|playground*)
526 # Unpack them in toplevel dir, so that they won't conflict with kde4-meta
527 # build packages from same svn location.
528 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
529 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
530 ;;
531 koffice)
532 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}"
533 ;;
534 *)
535 ESVN_REPO_URI="${ESVN_MIRROR}/trunk/${KMNAME}/${KMMODULE}"
536 ;;
537 esac
538 else
539 # kdelibs, kdepimlibs
540 ESVN_REPO_URI="${ESVN_MIRROR}/${branch_prefix}/${PN}"
541 ESVN_PROJECT="${PN}${ESVN_PROJECT_SUFFIX}"
542 fi
543 # @ECLASS-VARIABLE: ESVN_UP_FREQ
544 # @DESCRIPTION:
545 # This variable is used for specifying the timeout between svn synces
546 # for kde-base and koffice modules. Does not affect misc apps.
547 # Default value is 1 hour.
548 [[ ${KDEBASE} = kde-base || ${KDEBASE} = koffice ]] && ESVN_UP_FREQ=${ESVN_UP_FREQ:-1}
549 ;;
550 git)
551 local _kmname
552 # @ECLASS-VARIABLE: EGIT_MIRROR
553 # @DESCRIPTION:
554 # This variable allows easy overriding of default kde mirror service
555 # (anongit) with anything else you might want to use.
556 EGIT_MIRROR=${EGIT_MIRROR:=git://anongit.kde.org}
557
558 # @ECLASS-VARIABLE: EGIT_REPONAME
559 # @DESCRIPTION:
560 # This variable allows overriding of default repository
561 # name. Specify only if this differ from PN and KMNAME.
562 if [[ -n ${EGIT_REPONAME} ]]; then
563 # the repository and kmname different
564 _kmname=${EGIT_REPONAME}
565 elif [[ -n ${KMNAME} ]]; then
566 _kmname=${KMNAME}
567 else
568 _kmname=${PN}
569 fi
570
571 # default branching
572 [[ ${PV} != 9999* && ${KDEBASE} == kde-base ]] && \
573 EGIT_BRANCH="KDE/$(get_kde_version)"
574
575 # default repo uri
576 EGIT_REPO_URI="${EGIT_MIRROR}/${_kmname}"
577
578 debug-print "${FUNCNAME}: Repository: ${EGIT_REPO_URI}"
579 debug-print "${FUNCNAME}: Branch: ${EGIT_BRANCH}"
580 ;;
581 esac
582 }
583
584 case ${BUILD_TYPE} in
585 live) _calculate_live_repo ;;
586 *) _calculate_src_uri ;;
587 esac
588
589 debug-print "${LINENO} ${ECLASS} ${FUNCNAME}: SRC_URI is ${SRC_URI}"
590
591 # @ECLASS-VARIABLE: PREFIX
592 # @DESCRIPTION:
593 # Set the installation PREFIX for non kde-base applications. It defaults to /usr.
594 # kde-base packages go into KDE4 installation directory (/usr).
595 # No matter the PREFIX, package will be built against KDE installed in /usr.
596
597 # @FUNCTION: kde4-base_pkg_setup
598 # @DESCRIPTION:
599 # Do some basic settings
600 kde4-base_pkg_setup() {
601 debug-print-function ${FUNCNAME} "$@"
602
603 if use_if_iuse kdeprefix; then
604 eerror "Sorry, kdeprefix support has been removed."
605 eerror "Please remove kdeprefix from your USE variable."
606 die "kdeprefix support has been removed"
607 fi
608
609 if [[ ${CATEGORY}/${PN} != kde-base/kdelibs && ${CATEGORY}/${PN} != kde-base/kde-env ]] && \
610 { [[ ${KDE_REQUIRED} == always ]] || { [[ ${KDE_REQUIRED} == optional ]] && use kde; }; } && \
611 has_version kde-base/kdelibs[kdeprefix]; then
612 eerror "Sorry, kdeprefix support has been removed."
613 eerror "Please rebuild kdelibs without kdeprefix support."
614 die "kdeprefix support has been removed"
615 fi
616
617 # Don't set KDEHOME during compilation, it will cause access violations
618 unset KDEHOME
619
620 # Check if gcc compiler is fresh enough.
621 # In theory should be in pkg_pretend but we check it only for kdelibs there
622 # and for others we do just quick scan in pkg_setup because pkg_pretend
623 # executions consume quite some time.
624 # We can only do this for EAPI 4 or later because the MERGE_TYPE variable
625 # is otherwise undefined.
626 if [[ ${EAPI:-0} != 3 ]]; then
627 if [[ ${MERGE_TYPE} != binary ]]; then
628 [[ $(gcc-major-version) -lt 4 ]] || \
629 ( [[ $(gcc-major-version) -eq 4 && $(gcc-minor-version) -le 3 ]] ) \
630 && die "Sorry, but gcc-4.3 and earlier wont work for KDE (see bug 354837)."
631 fi
632 fi
633
634 KDEDIR=/usr
635 : ${PREFIX:=/usr}
636 EKDEDIR=${EPREFIX}/usr
637
638 # Point to correct QT plugins path
639 QT_PLUGIN_PATH="${EPREFIX}/usr/$(get_libdir)/kde4/plugins/"
640
641 # Fix XDG collision with sandbox
642 export XDG_CONFIG_HOME="${T}"
643 }
644
645 # @FUNCTION: kde4-base_src_unpack
646 # @DESCRIPTION:
647 # This function unpacks the source tarballs for KDE4 applications.
648 kde4-base_src_unpack() {
649 debug-print-function ${FUNCNAME} "$@"
650
651 if [[ ${BUILD_TYPE} = live ]]; then
652 case ${KDE_SCM} in
653 svn)
654 migrate_store_dir
655 subversion_src_unpack
656 ;;
657 git)
658 git-2_src_unpack
659 ;;
660 esac
661 else
662 unpack ${A}
663 fi
664 }
665
666 # @FUNCTION: kde4-base_src_prepare
667 # @DESCRIPTION:
668 # General pre-configure and pre-compile function for KDE4 applications.
669 # It also handles translations if KDE_LINGUAS is defined. See KDE_LINGUAS and
670 # enable_selected_linguas() and enable_selected_doc_linguas()
671 # in kde4-functions.eclass(5) for further details.
672 kde4-base_src_prepare() {
673 debug-print-function ${FUNCNAME} "$@"
674
675 # enable handbook and linguas only when not using live ebuild
676
677 # Only enable selected languages, used for KDE extragear apps.
678 if [[ -n ${KDE_LINGUAS} ]]; then
679 enable_selected_linguas
680 fi
681
682 # Enable/disable handbooks for kde4-base packages
683 # kde-l10n inherits kde4-base but is metpackage, so no check for doc
684 # kdelibs inherits kde4-base but handle installing the handbook itself
685 if ! has kde4-meta ${INHERITED} && in_iuse handbook; then
686 if [[ ${KDEBASE} == kde-base ]]; then
687 if [[ ${PN} != kde-l10n && ${PN} != kdepim-l10n && ${PN} != kdelibs ]] && use !handbook; then
688 # documentation in kde4-functions
689 : ${KDE_DOC_DIRS:=doc}
690 local dir
691 for dir in ${KDE_DOC_DIRS}; do
692 sed -e "\!^[[:space:]]*add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
693 -e "\!^[[:space:]]*ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
694 -e "\!^[[:space:]]*macro_optional_add_subdirectory[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
695 -e "\!^[[:space:]]*MACRO_OPTIONAL_ADD_SUBDIRECTORY[[:space:]]*([[:space:]]*${dir}[[:space:]]*)!s/^/#DONOTCOMPILE /" \
696 -i CMakeLists.txt || die "failed to comment out handbook"
697 done
698 fi
699 else
700 enable_selected_doc_linguas
701 fi
702 fi
703
704 # SCM bootstrap
705 if [[ ${BUILD_TYPE} = live ]]; then
706 case ${KDE_SCM} in
707 svn) subversion_src_prepare ;;
708 esac
709 fi
710
711 # Apply patches
712 base_src_prepare
713
714 # Save library dependencies
715 if [[ -n ${KMSAVELIBS} ]] ; then
716 save_library_dependencies
717 fi
718
719 # Inject library dependencies
720 if [[ -n ${KMLOADLIBS} ]] ; then
721 load_library_dependencies
722 fi
723
724 # Replace KDE4Workspace library targets
725 find "${S}" -name CMakeLists.txt \
726 -exec sed -i -r \
727 -e 's/\$\{KDE4WORKSPACE_TASKMANAGER_(LIBRARY|LIBS)\}/taskmanager/g' \
728 -e 's/\$\{KDE4WORKSPACE_KWORKSPACE_(LIBRARY|LIBS)\}/kworkspace/g' \
729 -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROLIFACES_(LIBRARY|LIBS)\}/solidcontrolifaces/g' \
730 -e 's/\$\{KDE4WORKSPACE_SOLIDCONTROL_(LIBRARY|LIBS)\}/solidcontrol/g' \
731 -e 's/\$\{KDE4WORKSPACE_PROCESSUI_(LIBRARY|LIBS)\}/processui/g' \
732 -e 's/\$\{KDE4WORKSPACE_LSOFUI_(LIBRARY|LIBS)\}/lsofui/g' \
733 -e 's/\$\{KDE4WORKSPACE_PLASMACLOCK_(LIBRARY|LIBS)\}/plasmaclock/g' \
734 -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERYCLIENT_(LIBRARY|LIBS)\}/nepomukqueryclient/g' \
735 -e 's/\$\{KDE4WORKSPACE_NEPOMUKQUERY_(LIBRARY|LIBS)\}/nepomukquery/g' \
736 -e 's/\$\{KDE4WORKSPACE_KSCREENSAVER_(LIBRARY|LIBS)\}/kscreensaver/g' \
737 -e 's/\$\{KDE4WORKSPACE_WEATHERION_(LIBRARY|LIBS)\}/weather_ion/g' \
738 -e 's/\$\{KDE4WORKSPACE_KWINEFFECTS_(LIBRARY|LIBS)\}/kwineffects/g' \
739 -e 's/\$\{KDE4WORKSPACE_KDECORATIONS_(LIBRARY|LIBS)\}/kdecorations/g' \
740 -e 's/\$\{KDE4WORKSPACE_KSGRD_(LIBRARY|LIBS)\}/ksgrd/g' \
741 -e 's/\$\{KDE4WORKSPACE_KEPHAL_(LIBRARY|LIBS)\}/kephal/g' \
742 {} + \
743 || die 'failed to replace KDE4Workspace library targets'
744
745 # Hack for manuals relying on outdated DTD, only outside kde-base/koffice/...
746 if [[ -z ${KDEBASE} ]]; then
747 find "${S}" -name "*.docbook" \
748 -exec sed -i -r \
749 -e 's:-//KDE//DTD DocBook XML V4\.1(\..)?-Based Variant V1\.[01]//EN:-//KDE//DTD DocBook XML V4.2-Based Variant V1.1//EN:g' {} + \
750 || die 'failed to fix DocBook variant version'
751 fi
752 }
753
754 # @FUNCTION: kde4-base_src_configure
755 # @DESCRIPTION:
756 # Function for configuring the build of KDE4 applications.
757 kde4-base_src_configure() {
758 debug-print-function ${FUNCNAME} "$@"
759
760 # Build tests in src_test only, where we override this value
761 local cmakeargs=(-DKDE4_BUILD_TESTS=OFF)
762
763 if use_if_iuse kdeenablefinal; then
764 cmakeargs+=(-DKDE4_ENABLE_FINAL=ON)
765 fi
766
767 if use_if_iuse debug; then
768 # Set "real" debug mode
769 CMAKE_BUILD_TYPE="Debugfull"
770 else
771 # Handle common release builds
772 append-cppflags -DQT_NO_DEBUG
773 fi
774
775 # Set distribution name
776 [[ ${PN} = kdelibs ]] && cmakeargs+=(-DKDE_DISTRIBUTION_TEXT=Gentoo)
777
778 # Here we set the install prefix
779 tc-is-cross-compiler || cmakeargs+=(-DCMAKE_INSTALL_PREFIX="${EPREFIX}${PREFIX}")
780
781 # Use colors
782 QTEST_COLORED=1
783
784 # Shadow existing installations
785 unset KDEDIRS
786
787 #qmake -query QT_INSTALL_LIBS unavailable when cross-compiling
788 tc-is-cross-compiler && cmakeargs+=(-DQT_LIBRARY_DIR=${ROOT}/usr/$(get_libdir)/qt4)
789 #kde-config -path data unavailable when cross-compiling
790 tc-is-cross-compiler && cmakeargs+=(-DKDE4_DATA_DIR=${ROOT}/usr/share/apps/)
791
792 # sysconf needs to be /etc, not /usr/etc
793 cmakeargs+=(-DSYSCONF_INSTALL_DIR="${EPREFIX}"/etc)
794
795 if [[ $(declare -p mycmakeargs 2>&-) != "declare -a mycmakeargs="* ]]; then
796 mycmakeargs=(${mycmakeargs})
797 fi
798
799 mycmakeargs=("${cmakeargs[@]}" "${mycmakeargs[@]}")
800
801 cmake-utils_src_configure
802 }
803
804 # @FUNCTION: kde4-base_src_compile
805 # @DESCRIPTION:
806 # General function for compiling KDE4 applications.
807 kde4-base_src_compile() {
808 debug-print-function ${FUNCNAME} "$@"
809
810 cmake-utils_src_compile "$@"
811 }
812
813 # @FUNCTION: kde4-base_src_test
814 # @DESCRIPTION:
815 # Function for testing KDE4 applications.
816 kde4-base_src_test() {
817 debug-print-function ${FUNCNAME} "$@"
818
819 # Override this value, set in kde4-base_src_configure()
820 mycmakeargs+=(-DKDE4_BUILD_TESTS=ON)
821 cmake-utils_src_configure
822 kde4-base_src_compile
823
824 # When run as normal user during ebuild development with the ebuild command, the
825 # kde tests tend to access the session DBUS. This however is not possible in a real
826 # emerge or on the tinderbox.
827 # > make sure it does not happen, so bad tests can be recognized and disabled
828 unset DBUS_SESSION_BUS_ADDRESS
829
830 if [[ ${VIRTUALX_REQUIRED} == always || ${VIRTUALX_REQUIRED} == test ]]; then
831 # check for sanity if anyone already redefined VIRTUALX_COMMAND from the default
832 if [[ ${VIRTUALX_COMMAND} != emake ]]; then
833 # surprise- we are already INSIDE virtualmake!!!
834 debug-print "QA Notice: This version of kde4-base.eclass includes the virtualx functionality."
835 debug-print " You may NOT set VIRTUALX_COMMAND or call virtualmake from the ebuild."
836 debug-print " Setting VIRTUALX_REQUIRED is completely sufficient. See the"
837 debug-print " kde4-base.eclass docs for details... Applying workaround."
838 cmake-utils_src_test
839 else
840 VIRTUALX_COMMAND="cmake-utils_src_test" virtualmake
841 fi
842 else
843 cmake-utils_src_test
844 fi
845 }
846
847 # @FUNCTION: kde4-base_src_install
848 # @DESCRIPTION:
849 # Function for installing KDE4 applications.
850 kde4-base_src_install() {
851 debug-print-function ${FUNCNAME} "$@"
852
853 if [[ -n ${KMSAVELIBS} ]] ; then
854 install_library_dependencies
855 fi
856
857 # Install common documentation of KDE4 applications
858 local doc
859 if ! has kde4-meta ${INHERITED}; then
860 for doc in "${S}"/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
861 [[ -f ${doc} && -s ${doc} ]] && dodoc "${doc}"
862 done
863 for doc in "${S}"/*/{AUTHORS,CHANGELOG,ChangeLog*,README*,NEWS,TODO,HACKING}; do
864 [[ -f ${doc} && -s ${doc} ]] && newdoc "${doc}" "$(basename $(dirname ${doc})).$(basename ${doc})"
865 done
866 fi
867
868 cmake-utils_src_install
869
870 # In EAPI 4+, we don't want ${PREFIX}/share/doc/HTML to be compressed,
871 # because then khelpcenter can't find the docs
872 [[ ${EAPI:-0} != 3 && -d ${ED}/${PREFIX}/share/doc/HTML ]] &&
873 docompress -x ${PREFIX}/share/doc/HTML
874 }
875
876 # @FUNCTION: kde4-base_pkg_preinst
877 # @DESCRIPTION:
878 # Function storing icon caches
879 kde4-base_pkg_preinst() {
880 debug-print-function ${FUNCNAME} "$@"
881
882 gnome2_icon_savelist
883 if [[ ${BUILD_TYPE} == live && ${KDE_SCM} == svn ]]; then
884 subversion_pkg_preinst
885 fi
886 }
887
888 # @FUNCTION: kde4-base_pkg_postinst
889 # @DESCRIPTION:
890 # Function to rebuild the KDE System Configuration Cache after an application has been installed.
891 kde4-base_pkg_postinst() {
892 debug-print-function ${FUNCNAME} "$@"
893
894 gnome2_icon_cache_update
895 fdo-mime_desktop_database_update
896 fdo-mime_mime_database_update
897 buildsycoca
898
899 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
900 if use_if_iuse kdeenablefinal; then
901 echo
902 ewarn "WARNING! you have kdeenable final useflag enabled."
903 ewarn "This useflag needs to be enabled on ALL kde using packages and"
904 ewarn "is known to cause issues."
905 ewarn "You are using this setup at your own risk and the kde team does not"
906 ewarn "take responsibilities for dead kittens."
907 echo
908 fi
909 if [[ ${BUILD_TYPE} = live ]]; then
910 echo
911 einfo "WARNING! This is an experimental live ebuild of ${CATEGORY}/${PN}"
912 einfo "Use it at your own risk."
913 einfo "Do _NOT_ file bugs at bugs.gentoo.org because of this ebuild!"
914 echo
915 fi
916 # for all 3rd party soft tell user that he SHOULD install kdebase-startkde or kdebase-runtime-meta
917 if [[ ${KDEBASE} != kde-base ]] && \
918 ! has_version 'kde-base/kdebase-runtime-meta' && \
919 ! has_version 'kde-base/kdebase-startkde'; then
920 if [[ ${KDE_REQUIRED} == always ]] || ( [[ ${KDE_REQUIRED} == optional ]] && use kde ); then
921 echo
922 ewarn "WARNING! Your system configuration contains neither \"kde-base/kdebase-runtime-meta\""
923 ewarn "nor \"kde-base/kdebase-startkde\". You need one of above."
924 ewarn "With this setting you are unsupported by KDE team."
925 ewarn "All missing features you report for misc packages will be probably ignored or closed as INVALID."
926 fi
927 fi
928 fi
929 }
930
931 # @FUNCTION: kde4-base_pkg_postrm
932 # @DESCRIPTION:
933 # Function to rebuild the KDE System Configuration Cache after an application has been removed.
934 kde4-base_pkg_postrm() {
935 debug-print-function ${FUNCNAME} "$@"
936
937 gnome2_icon_cache_update
938 fdo-mime_desktop_database_update
939 fdo-mime_mime_database_update
940 buildsycoca
941 }

  ViewVC Help
Powered by ViewVC 1.1.20